// Dawid Seredyski    5. semestr, ECY
#include <iostream>
#include <fstream>
#include <sstream>
#include <string>

using namespace std;

void test_callback (ios_base::event ev, ios_base& iosobj, int index)
{
  switch (ev)
  {
    case ios_base::copyfmt_event:
      cout << "copyfmt_event\n"; break;
    case ios_base::imbue_event:
      cout << "imbue_event\n"; break;
    case ios_base::erase_event:
		if(&iosobj!=(ios_base*)&cout)
			cout << "erase_event\n";
		break;
  }
}

int main()
{
	stringbuf sb,sb2;

	// utworzenie strumieni i powizanie ich z buforami typu stringbuf
	ostream os(&sb);				// utworzenie strumienia przypisanego
							// do bufora pliku
	ostream os2(&sb2);				// utworzenie strumienia przypisanego
							// do bufora pliku

	// ustawieni funkcji wywoywanej przy niektrych zdarzeniach
	os.register_callback (test_callback,0);

	// powizanie dwch strumieni
	// kada operacja i/o na strumieniu os bdzie wpisywana do os2
	os.tie(&os2);
	os << "Test sentence\n";

	// os bdzie pisa do bufora cout
	os.rdbuf(cout.rdbuf());
	os<<"uzycie innego strumienia do wypisania tekstu na konsole"<<endl;
	// os bdzie pisa do bufora sb
	os.rdbuf(&sb);

	// metoda zapisujca napis jako tablic bajtw
	os.write ("This is an apple",16);
	os.flush();
	// odczytanie pozycji wskanika zapisu
	int pos=os.tellp();
	// przesunicie wskanika zapisu o 7 bajtw do tyu
	os.seekp (pos-7);
	os.write (" sam",4);
	// przesunicie wskanika na koniec pliku
	os.seekp(0,ios_base::end);
	// zapis pojedynczego znaku
	os.put('\n');
	// zapis formatowanego tekstu
	os<<"test"<<endl;
	// wywietlenie wartoci znacznika koca stumienia - w przypadku
	// strumienia wyjciowego, zawsze rwnego 0
	cout<<os.eof()<<endl;

	// ustawienie staej, okrelonej szerokoci pola przy formatowaniu liczb
	os.width(10);
	// ustawienie wypenienia pola liczy
	os.fill('#');

	// skopiowanie stylu formatowania liczb do strumienia cout
	cout.copyfmt(os);

	// dla obu strumieni liczba zostanie sformatowana w ten sam sposb
	cout<<25<<endl;
	os<<25<<endl;

	// wyjustowanie do lewej
	cout.setf ( ios::left, ios::adjustfield );
	// ustawienie szerokoci pola liczby
	cout.width(10);
	// ustawienie wypenienia niezapisanych znakw pola liczby
	cout.fill('#');
	cout<<25<<endl;
	cout<<25<<endl;
	cout.flush();

	cout.width(0);
	// liczby formatowane do systemu szesnastkowego
	cout.setf ( ios::hex, ios::basefield );
	// wyswietl 0x przed liczb szesnastkow
	cout.setf ( ios::showbase );
	cout << 100 << endl;
	// nie wywietlaj 0x przed liczb szesnastkow
	cout.setf ( (std::_Ios_Fmtflags)0,ios::showbase );
	cout << 100 << endl;
	// liczby formatowane do systemu dziesitnego
	cout.setf ( ios::dec, ios::basefield );
	cout<<"flags: "<<cout.flags()<<endl;
	cout << 100 << endl;

	// ustawienie sposobu formatowania liczb w zalenoci od lokalnych ustawie
	{
		locale mylocale("");
		cout.imbue( mylocale );
		cout<<3.1415<<endl;
	}
	{
		locale mylocale("C");
		cout.imbue( mylocale );
		cout<<3.1415<<endl;
	}

	// zmiana dokadnoci formatowanych liczb zmiennopozycyjnych
	// dla notacji (default) okrela cakowit liczb wypisanych cyfr
	cout.precision(3);
	cout<<13.1415<<endl;

	// zmiana dokadnoci formatowanych liczb zmiennopozycyjnych
	// dla notacji (fixed) okrela liczb wypisanych cyfr po przecinku
	cout.setf(ios::fixed,ios::floatfield);
	cout.precision(3);
	cout<<13.1415<<endl;

	// FUNKCJE OPERUJCE NA ZNACZNIKACH BDW
	// pocztkowe ustawienie znacznikw bdw
	os.clear();
	cout<<"clear()"<<endl;
	// sprawdzenie, czy poprzednia operacja zakoczya si powanym bdem
	cout<<"bad(): "<<os.bad()<<endl;
	// sprawdzenie, czy poprzednia operacja nie powioda si
	cout<<"fail(): "<<os.fail()<<endl;
	// sprawdzenie, czy strumie jest ok.
	cout<<"good(): "<<os.good()<<endl;
	// odczytanie zmiennej stanu, zawierajcej znaczniki bdw
	cout<<"rdstate(): "<<os.rdstate()<<endl;

	cout<<endl<<"wlaczenie generowania wyjatkow..."<<endl;
	// wczenie generowania wyjtkw przez strumie
	os.exceptions(ios::eofbit | ios::failbit | ios::badbit);
	try
	{
		// cofnicie wskanika pozycji w pliku do niedozwolonej wartoci
		cout<<"seek(-1000)"<<endl;
		os.seekp(-1000);
	}
	catch(ifstream::failure e)
	{
		cout<<"zlapano wyjatek: "<<e.what()<<endl;
	}

	cout<<endl<<"wylaczenie generowania wyjatkow..."<<endl;
	// wyczenie generowania wyjtkw przez strumie
	os.exceptions(ios::goodbit);
	// cofnicie wskanika pozycji w pliku do niedozwolonej wartoci
	cout<<"seek(-1000)"<<endl;
	os.seekp(-1000);
	// sprawdzenie, czy poprzednia operacja zakoczya si powanym bdem
	cout<<"bad(): "<<os.bad()<<endl;
	// sprawdzenie, czy poprzednia operacja nie powioda si
	cout<<"fail(): "<<os.fail()<<endl;
	// dziaanie operatora ! jest takie samo jak metody fail()
	cout<<"operator!: "<<!os<<endl;
	// sprawdzenie, czy strumie jest ok.
	cout<<"good(): "<<os.good()<<endl;
	// dziaanie operatora (void*) jest podobne do metody good()
	cout<<"operator (void*): "<<(void*)os<<endl;
	// odczytanie zmiennej stanu, zawierajcej znaczniki bdw
	cout<<"rdstate(): "<<os.rdstate()<<endl;

	// 'wyczyszczenie' znacznikw
	os.clear();
	// ustawienie niedozwolonego bufora (NULL)
	os.rdbuf(0);
	// zapis danych
	os<<"A";
	cout<<endl<<"wykonanie niedozwolonej operacji - zapis do nieistniejacego bufora"<<endl;
	// sprawdzenie, czy poprzednia operacja zakoczya si powanym bdem
	cout<<"bad(): "<<os.bad()<<endl;
	// sprawdzenie, czy poprzednia operacja nie powioda si
	cout<<"fail(): "<<os.fail()<<endl;
	// sprawdzenie, czy strumie jest ok.
	cout<<"good(): "<<os.good()<<endl;
	// odczytanie zmiennej stanu, zawierajcej znaczniki bdw
	cout<<"rdstate(): "<<os.rdstate()<<endl;

	return 0;
}
